<?

 /*************************************************************************************
 * Filename: modules/pluginConfigs.php
 *
 * This file is part of the DocIT JAS plugin.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The DocIT JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/docit/
 *************************************************************************************/


 require_once($_path["include"]."module.php");

 class Plugin_Module_docit_pluginConfigs extends Module
 {
  function Plugin_Module_docit_pluginConfigs(&$data)
  {
   parent::Module($data);

   if($this->data->module!="pluginConfigs")
    $this->extend("pluginConfigs");

   $this->data->title="DocIT plugin configuration";

   $this->data->addField("listtype", "enum", "all", "reload", false, false, "Topic", "Show");
   $this->data->enumOptions("listtype", "Topic", "Tree", "Index", "Latest comments");

   $this->data->addField("listcatnr", "nr", "all", "", false, false, 1, "List category");
   $this->data->addReference("listcatnr", "categories", "nr", "*:1");
   $this->data->addField("listitems", "nr", "all", "", 0, 100, 10, "Number of comments");

   $this->data->addField("cmspage", "boolean", "all", "reload", false, false, false, "Use CMS page");
   $this->data->addField("cmspagenr", "nr", "all", "", false, false, false, "CMS page");
   $this->data->addReference("cmspagenr", "categories", "nr", "*:0");

   $this->data->addField("templateitem", "localfile", "all", "recursive", false, 255, "", "Item template");
   $this->data->addField("templatelist", "localfile", "all", "recursive", false, 255, "", "List template");

   $this->data->group("Show", "listtype", "listcatnr", "cmspage", "cmspagenr");
   $this->data->group("Alternative templates", "templateitem", "templatelist");
  }

  function postInit()
  {
   global $_path;

   $this->data->setFileDir("templateitem", $_path["project"]["templates"]);
   $this->data->setFileExtensions("templateitem", "html", "htm");
   $this->data->setFileDir("templatelist", $_path["project"]["templates"]);
   $this->data->setFileExtensions("templatelist", "html", "htm");

   return $this->customizeFields();
  }
  function copyPostGet(){return $this->customizeFields();}
  function editPostGet(){return $this->customizeFields();}
  function movePostGet(){return $this->customizeFields();}
  function deletePostGet(){return $this->customizeFields();}

  function customizeFields()
  {
   if($this->data->getValue("listtype")=="Topic")
   {
    $this->data->field["listitems"]["properties"].=";hidden";

    $this->data->resetField("cmspage");

    if($this->data->getValue("cmspage"))
     $this->data->resetField("cmspagenr");
    else
     $this->data->field["cmspagenr"]["properties"].=";hidden";

    $this->data->resetField("templateitem");
    $this->data->field["templatelist"]["properties"].=";hidden";
   }
   else if($this->data->getValue("listtype")=="Tree")
   {
    $this->data->field["listitems"]["properties"].=";hidden";

    $this->data->resetField("cmspage");

    if($this->data->getValue("cmspage"))
     $this->data->resetField("cmspagenr");
    else
     $this->data->field["cmspagenr"]["properties"].=";hidden";

    $this->data->field["templateitem"]["properties"].=";hidden";
    $this->data->resetField("templatelist");
   }
   else if($this->data->getValue("listtype")=="Index")
   {
    $this->data->field["listitems"]["properties"].=";hidden";

    $this->data->field["cmspage"]["properties"].=";hidden";
    $this->data->field["cmspagenr"]["properties"].=";hidden";

    $this->data->field["templateitem"]["properties"].=";hidden";
    $this->data->resetField("templatelist");
   }
   else //Latest comments
   {
    $this->data->resetField("listitems");

    $this->data->field["cmspage"]["properties"].=";hidden";
    $this->data->field["cmspagenr"]["properties"].=";hidden";

    $this->data->field["templateitem"]["properties"].=";hidden";

    $this->data->field["templateitem"]["properties"].=";hidden";
    $this->data->resetField("templatelist");
    $this->data->field["templatelist"]["title"]="Latest template";
   }

   return true;
  }

 }
?>
